Panda3D

Loading...
Searching...
No Matches
Public Member Functions | Static Public Member Functions | List of all members
AuxSceneData Class Reference

This is a base class for a generic data structure that can be attached per- instance to the camera, to store per-instance data that must be preserved over multiple frames. More...

`#include "auxSceneData.h"`

Inheritance diagram for AuxSceneData:

## Public Member Functions
virtual TypeHandle | force_init_type ()
double | get_duration () const
| Returns the minimum length in time, in seconds, to keep this AuxSceneData object around in the scene graph after the last time it was rendered.
double | get_expiration_time () const
| Returns the frame_time at which this AuxSceneData object is currently scheduled to be removed from the scene graph.
double | get_last_render_time () const
| Returns the last time this object was used during traversal (according to set_last_render_time()).
virtual TypeHandle | get_type () const
virtual void | output (std::ostream &out) const
void | set_duration (double duration)
| Specifies the minimum length in time, in seconds, to keep this AuxSceneData object around in the scene graph after the last time it was rendered.
void | set_last_render_time (double render_time)
| Should be called with the current frame_time each time the AuxSceneData is used during traversal.
virtual void | write (std::ostream &out, int indent_level=0) const
Public Member Functions inherited from TypedReferenceCount
| TypedReferenceCount (const TypedReferenceCount &copy)
void | operator= (const TypedReferenceCount &copy)
Public Member Functions inherited from TypedObject
| TypedObject (const TypedObject &copy)=default
TypedObject * | as_typed_object ()
| Returns the object, upcast (if necessary) to a TypedObject pointer.
const TypedObject * | as_typed_object () const
| Returns the object, upcast (if necessary) to a TypedObject pointer.
int | get_best_parent_from_Set (const std::set< int > &) const
int | get_type_index () const
| Returns the internal index number associated with this object's TypeHandle, a unique number for each different type.
bool | is_exact_type (TypeHandle handle) const
| Returns true if the current object is the indicated type exactly.
bool | is_of_type (TypeHandle handle) const
| Returns true if the current object is or derives from the indicated type.
TypedObject & | operator= (const TypedObject &copy)=default
Public Member Functions inherited from MemoryBase
void | operator delete (void *, void *)
void | operator delete (void *ptr)
void | operator delete[] (void *, void *)
void | operator delete[] (void *ptr)
void * | operator new (size_t size)
void * | operator new (size_t size, void *ptr)
void * | operator new[] (size_t size)
void * | operator new[] (size_t size, void *ptr)
Public Member Functions inherited from ReferenceCount
int | get_ref_count () const
WeakReferenceList * | get_weak_list () const
| Returns the WeakReferenceList associated with this ReferenceCount object.
bool | has_weak_list () const
| Returns true if this particular ReferenceCount object has a WeakReferenceList created, false otherwise.
void | local_object ()
| This function should be called, once, immediately after creating a new instance of some ReferenceCount-derived object on the stack.
void | ref () const
| Explicitly increments the reference count.
bool | ref_if_nonzero () const
| Atomically increases the reference count of this object if it is not zero.
bool | test_ref_count_integrity () const
| Does some easy checks to make sure that the reference count isn't completely bogus.
bool | test_ref_count_nonzero () const
| Does some easy checks to make sure that the reference count isn't zero, or completely bogus.
virtual bool | unref () const
| Explicitly decrements the reference count.
bool | unref_if_one () const
| Atomically decreases the reference count of this object if it is one.
WeakReferenceList * | weak_ref ()
| Adds the indicated PointerToVoid as a weak reference to this object.
void | weak_unref ()
| Removes the indicated PointerToVoid as a weak reference to this object.

## Static Public Member Functions
static TypeHandle | get_class_type ()
static void | init_type ()
Static Public Member Functions inherited from TypedReferenceCount
static TypeHandle | get_class_type ()
static void | init_type ()
Static Public Member Functions inherited from TypedObject
static TypeHandle | get_class_type ()
static void | init_type ()
| This function is declared non-inline to work around a compiler bug in g++ 2.96.
Static Public Member Functions inherited from ReferenceCount
static TypeHandle | get_class_type ()
static void | init_type ()

## Additional Inherited Members
Public Attributes inherited from TypedObject
| get_type
Public Attributes inherited from ReferenceCount
| get_ref_count
| Returns the current reference count.

## Detailed Description

This is a base class for a generic data structure that can be attached per- instance to the camera, to store per-instance data that must be preserved over multiple frames.

In particular, this is used to implement the FadeLODNode, which must remember during traversal at what point it is in the fade, separately for each instance and for each camera.

Definition at line 31 of file auxSceneData.h.

## Member Function Documentation

## ◆ force_init_type()

virtual TypeHandle AuxSceneData::force_init_type | ( |  | ) |
| inline virtual

Reimplemented from TypedReferenceCount.

Definition at line 63 of file auxSceneData.h.

## ◆ get_class_type()

static TypeHandle AuxSceneData::get_class_type | ( |  | ) |
| inline static

Definition at line 52 of file auxSceneData.h.

## ◆ get_duration()

double AuxSceneData::get_duration | ( |  | ) | const
| inline

Returns the minimum length in time, in seconds, to keep this AuxSceneData object around in the scene graph after the last time it was rendered.

Definition at line 39 of file auxSceneData.I.

## ◆ get_expiration_time()

double AuxSceneData::get_expiration_time | ( |  | ) | const
| inline

Returns the frame_time at which this AuxSceneData object is currently scheduled to be removed from the scene graph.

Definition at line 66 of file auxSceneData.I.

Referenced by FadeLODNode::cull_callback().

## ◆ get_last_render_time()

double AuxSceneData::get_last_render_time | ( |  | ) | const
| inline

Returns the last time this object was used during traversal (according to set_last_render_time()).

Definition at line 57 of file auxSceneData.I.

Referenced by FadeLODNode::cull_callback().

## ◆ get_type()

virtual TypeHandle AuxSceneData::get_type | ( |  | ) | const
| inline virtual

Reimplemented from TypedReferenceCount.

Definition at line 60 of file auxSceneData.h.

## ◆ init_type()

static void AuxSceneData::init_type | ( |  | ) |
| inline static

Definition at line 55 of file auxSceneData.h.

## ◆ output()

void AuxSceneData::output | ( | std::ostream & | out | ) | const
| virtual

Definition at line 22 of file auxSceneData.cxx.

## ◆ set_duration()

void AuxSceneData::set_duration | ( | double | duration | ) |
| inline

Specifies the minimum length in time, in seconds, to keep this AuxSceneData object around in the scene graph after the last time it was rendered.

Definition at line 30 of file auxSceneData.I.

Referenced by FadeLODNode::cull_callback().

## ◆ set_last_render_time()

void AuxSceneData::set_last_render_time | ( | double | render_time | ) |
| inline

Should be called with the current frame_time each time the AuxSceneData is used during traversal.

Definition at line 48 of file auxSceneData.I.

Referenced by FadeLODNode::cull_callback().

## ◆ write()

void AuxSceneData::write | ( | std::ostream & | out,
|  | int | indent_level = 0 ) const
| virtual

Definition at line 30 of file auxSceneData.cxx.

The documentation for this class was generated from the following files:

- panda/src/pgraph/auxSceneData.h
- panda/src/pgraph/auxSceneData.cxx
- panda/src/pgraph/auxSceneData.I